unit Tethering;

{
  POUIT

  1. zavolat VytvorSpravce
  - aProfileText: text, pomoc kterho se bude dan profil identifikovat, nejlpe tam dt jmno PC, usera nebo nco podobnho
  - aPassword: heslo nutn pro sprovn, stejn na obou stranch
  - aOutputListBox - ListBox pro vpis najitch profil (pozor je to var)
  2. DLEIT - piadit profilu event OnResourceReceived nap. TethSpr.MyTetheringAppProfile.OnResourceReceived := ResourceReceived;
  a danou metodu implementovat - definuje, co se dje pi pijet dat
  - pklad implementace na konci unity ve vypoznmkovan metod
  3. zavolat NajdiZarizeni
  - defaultn trv 5 vtein
  - nalezen profily se vypou do OutputListBoxu
  4. ideln klikem na profil vypsan v ListBoxu zavolat Pripoj s danm ProfileText jako parametrem
  5. tm je navzno pipojen a je mon poslat text a soubory
  6. PosliText
  - Popis - pi pijet lze pest jako AResource.Hint
  - Text - pi pijet lze pest jako AResource.Value.AsString
  - Profil - vzdlen profil, na kter se m text poslat
  7. PosliSoubor
  - Popis - pi pijet lze pest jako AResource.Hint - lze tam napklad poslat po jakm nzvem se m soubor uloit
  - Cesta - absolutn cesta k souboru, kter se m poslat
  - Profil - vzdlen profil, na kter se m soubor poslat

}

interface

uses
{$IFDEF MSWINDOWS}
  Vcl.StdCtrls, Vcl.Dialogs,
{$ENDIF}
{$IFDEF ANDROID}
  FMX.ListBox, FMX.Dialogs,
{$ENDIF}
{$IFDEF IOS}
  FMX.ListBox, FMX.Dialogs,
{$ENDIF}
  SysUtils, Types, UITypes, Classes, Variants, IOUtils,
  IPPeerClient, IPPeerServer, System.Tether.Manager, System.Tether.AppProfile;

type
  TTetheringSpravce = class(TObject)

    MyTetheringManager: TTetheringManager;
    MyTetheringAppProfile: TTetheringAppProfile;
    pripojeno: boolean;
    OutputListBox: TListBox;

    procedure NajdiZarizeni;
    procedure NactiProfily;
    function Pripoj(ProfileText: string): boolean;
    function PosliText(Popis, Text, Profil: string): boolean;
    function PosliSoubor(Popis, Cesta, Profil: string): boolean;

    procedure EndManagersDiscovery(const Sender: TObject;
      const ARemoteManagers: TTetheringManagerInfoList);
    procedure EndProfilesDiscovery(const Sender: TObject;
      const ARemoteProfiles: TTetheringProfileInfoList);
    procedure RequestManagerPassword(const Sender: TObject;
      const ARemoteIdentifier: string; var Password: string);
    procedure RemoteManagerShutdown(const Sender: TObject;
      const AManagerIdentifier: string);

  public
    constructor VytvorSpravce(aProfileText, aPassword: string;
      var aOutputListBox: TListBox);
    procedure ZrusSpravce;
  end;

implementation

constructor TTetheringSpravce.VytvorSpravce(aProfileText, aPassword: string;
  var aOutputListBox: TListBox);
begin
  inherited Create;
  MyTetheringManager := TTetheringManager.Create(nil);
  MyTetheringManager.Text := 'TproTetheringManager';
  MyTetheringManager.Password := aPassword;
  MyTetheringManager.SynchronizeEvents := true;

  MyTetheringManager.OnEndManagersDiscovery := EndManagersDiscovery;
  MyTetheringManager.OnEndProfilesDiscovery := EndProfilesDiscovery;
  MyTetheringManager.OnRequestManagerPassword := RequestManagerPassword;
  MyTetheringManager.OnRemoteManagerShutdown := RemoteManagerShutdown;

  MyTetheringAppProfile := TTetheringAppProfile.Create(nil);
  MyTetheringAppProfile.Manager := MyTetheringManager;
  MyTetheringAppProfile.Text := aProfileText;
  MyTetheringAppProfile.SynchronizeEvents := true;

  OutputListBox := aOutputListBox;

end;

procedure TTetheringSpravce.ZrusSpravce;
var
  I: Integer;
begin
  for I := MyTetheringManager.PairedManagers.Count - 1 downto 0 do
    MyTetheringManager.UnPairManager(MyTetheringManager.PairedManagers[I]);
  MyTetheringManager.Free;
  MyTetheringAppProfile.Free;
end;

procedure TTetheringSpravce.NajdiZarizeni;
var
  I: Integer;
begin
  OutputListBox.Items.Clear;
  for I := MyTetheringManager.PairedManagers.Count - 1 downto 0 do
    MyTetheringManager.UnPairManager(MyTetheringManager.PairedManagers[I]);
  // odparovani soucasnych manageru

  MyTetheringManager.DiscoverManagers;
  // objevovani dostupnych manageru, po skonceni se spousti OnEndManagersDiscovery event, defaultn trv 5 vtein

end;

function TTetheringSpravce.Pripoj(ProfileText: string): boolean;
var
  I: Integer;
begin
  result := false;
  for I := 0 to MyTetheringManager.RemoteProfiles.Count - 1 do
  begin
    if MyTetheringManager.RemoteProfiles[I].ProfileText = ProfileText then
    begin
      pripojeno := MyTetheringAppProfile.Connect
        (MyTetheringManager.RemoteProfiles[I]);
      // pripojeni na profil v manageru

      ShowMessage('Pipojeno k: ' + MyTetheringManager.RemoteProfiles[I]
        .ProfileText);
      break;
    end;
  end;
  result := pripojeno;
end;

function TTetheringSpravce.PosliText(Popis, Text, Profil: string): boolean;
begin
  result := false;
  if not pripojeno then
  begin
    ShowMessage('Nepipojeno.');
    exit;
  end;
  try
    result := MyTetheringAppProfile.SendString(MyTetheringManager.RemoteProfiles
      [0], Popis, Text);
  except
    on E: Exception do
      ShowMessage(E.Message);
  end;
end;

function TTetheringSpravce.PosliSoubor(Popis, Cesta, Profil: string): boolean;
var
  Stream: TFileStream;
  I: Integer;
begin
  result := false;
  if not pripojeno then
  begin
    ShowMessage('Nepipojeno.');
    exit;
  end;
  if TFile.Exists(Cesta) then
  begin
    for I := 0 to MyTetheringManager.RemoteProfiles.Count - 1 do
    begin
      if MyTetheringManager.RemoteProfiles[I].ProfileText = Profil then
      begin
        try
          try
            Stream := TFileStream.Create(Cesta, fmOpenRead);
            result := MyTetheringAppProfile.SendStream
              (MyTetheringManager.RemoteProfiles[I], Popis, Stream);
            break;
          except
            on E: Exception do
              ShowMessage(E.Message);
          end;
        finally
          Stream.Free;
        end;
      end;
    end;
  end
  else
    ShowMessage('Chyb soubor k posln: ' + Cesta);
end;

procedure TTetheringSpravce.NactiProfily;
var
  I: Integer;
begin
  pripojeno := false;
  OutputListBox.Clear;
  for I := 0 to MyTetheringManager.RemoteProfiles.Count - 1 do
    OutputListBox.Items.Add(MyTetheringManager.RemoteProfiles[I].ProfileText);
end;

procedure TTetheringSpravce.EndManagersDiscovery(const Sender: TObject;
  const ARemoteManagers: TTetheringManagerInfoList);
var
  I: Integer;
begin
  if Assigned(OutputListBox) then
  begin
    for I := 0 to ARemoteManagers.Count - 1 do
    begin
      if ARemoteManagers[I].ManagerText = 'TproTetheringManager' then
      begin
        MyTetheringManager.PairManager(ARemoteManagers[I]);
        // po sprovn se vol EndProfilesDiscovery
      end;
    end;
  end;
end;

procedure TTetheringSpravce.EndProfilesDiscovery(const Sender: TObject;
  const ARemoteProfiles: TTetheringProfileInfoList);
begin
  NactiProfily;
end;

procedure TTetheringSpravce.RemoteManagerShutdown(const Sender: TObject;
  const AManagerIdentifier: string);
begin
  NactiProfily;
end;

procedure TTetheringSpravce.RequestManagerPassword(const Sender: TObject;
  const ARemoteIdentifier: string; var Password: string);
begin
  Password := MyTetheringManager.Password;
end;

// procedure TTetheringSpravce.ResourceReceived(const Sender: TObject;
// const AResource: TRemoteResource);
// var
// fs: TFileStream;
// ms: TMemoryStream;
// begin
// if AResource.ResType = TRemoteResourceType.Data then // text
// begin
// OutputListBox.Items.Add(AResource.Hint + ' ; ' + AResource.Value.AsString);
// end;
//
// if AResource.ResType = TRemoteResourceType.Stream then // soubor
// begin
// fs := TFileStream.Create('D:\' + AResource.Hint, fmCreate);
// try
// ms := TMemoryStream.Create;
// ms := TMemoryStream(AResource.Value.AsStream);
// ms.Position := 0;
// ms.SaveToStream(fs);
// finally
// freeandnil(fs);
// end;
// end;
//
// end;

end.
